#ifdef RCSID
static char RCSid[] =
"$Header$";
#endif

/* Copyright (c) 1999 by Michael J. Roberts.  All Rights Reserved. */
/*
Name
  vmhostsi.cpp - stdio-based VM host application environment
Function
  
Notes
  
Modified
  08/06/99 MJRoberts  - Creation
*/

#include "t3std.h"
#include "os.h"
#include "resload.h"
#include "vmhost.h"
#include "vmhostsi.h"

/*
 *   initialize 
 */
CVmHostIfcStdio::CVmHostIfcStdio(const char *exe_path)
{
    char buf[OSFNMAX];


    /* 
     *   Create the resource loader for character mapping files in the
     *   same directory as the executable. 
     */
    os_get_path_name(buf, sizeof(buf), exe_path);
    cmap_loader_ = new CResLoader(buf);

    /* set the executable filename in the loader */
    cmap_loader_->set_exe_filename(exe_path);

    /* allow any I/O operations initially */
    io_safety_ = VM_IO_SAFETY_MINIMUM;
}

/*
 *   delete 
 */
CVmHostIfcStdio::~CVmHostIfcStdio()
{
    /* delete our character map resource loader */
    delete cmap_loader_;
}
