#ifdef RCSID
static char RCSid[] =
"$Header$";
#endif

/* Copyright (c) 1999 by Michael J. Roberts.  All Rights Reserved. */
/*
Name
  vmimg_nd.cpp - T3 VM image file reader - NON-DEBUG implementation
Function
  This file implements certain image file reader functions for 
  non-debug versions of the interpreter.  This implementation allows
  linking a smaller version of the interpreter executable that doesn't
  require a bunch of functionality only needed for an interactive
  debugger.
Notes
  
Modified
  12/03/99 MJRoberts  - Creation
*/

#include <stdlib.h>

#include "t3std.h"
#include "vmtype.h"
#include "vmimage.h"

/* ------------------------------------------------------------------------ */
/* 
 *   load a Source File List block - source file blocks are needed only
 *   for interactive debugging, so we can simply ignore this information 
 */
void CVmImageLoader::load_srcfiles(VMG_ ulong siz)
{
    /* skip the block */
    fp_->skip_ahead(siz);
}

/* ------------------------------------------------------------------------ */
/*
 *   load a Global Symbols block - symbols are needed only for interactive
 *   debugging, so we can simply ignore this information 
 */
void CVmImageLoader::load_gsym(VMG_ ulong siz)
{
    /* skip the blcok */
    fp_->skip_ahead(siz);
}

/* ------------------------------------------------------------------------ */
/*
 *   load a Method Header List block - this block is needed only for
 *   interactive debugging, so we can simply ignore this information 
 */
void CVmImageLoader::load_mhls(VMG_ ulong siz)
{
    /* skip the blcok */
    fp_->skip_ahead(siz);
}
